<?php

/**
 * PHP versions 4 and 5
 *
 * LICENSE: This source file is subject to version 3.0 of the PHP license
 * that is available through the world-wide-web at the following URI:
 * http://www.php.net/license.  If you did not receive a copy of
 * the PHP License and are unable to obtain it through the web, please
 * send a note to license@php.net so we can mail you a copy immediately.
 *
 * @category   Forum
 * @package    QuickTalk
 * @author     Philippe Vandenberghe <info@qt-cute.org>
 * @copyright  2008-2012 The PHP Group
 * @version    2.0 build:20090331
 * @link       http://www.qt-cute/doc/package/qtf
 * @since      File available since Release 1.0.0
 * @deprecated File deprecated in Release 3.0.0
 */

session_start();
require_once('bin/qtf_init.php');
include(Translate('qtf_adm.php'));
include(Translate('qtfm_import_qtf.php'));
if ( $oVIP->role!='A' ) die($L['E_admin']);

// INITIALISE

$s = -1;
$strTitle   = '';
$strFormat  = 'CSV';
$strDelimit = ';';
$strEnclose = '"';
$strNull    = 'NULL';
$strDropbbc = 'N';
$strSkip    = 'N';
$strStatus  = '0';

$oVIP->selfurl = 'qtfm_import_qtf_adm.php';
$oVIP->selfname = $L['import_qtf']['Admin'];
$oVIP->exiturl = $oVIP->selfurl;
$oVIP->exitname = $oVIP->selfname;
$strPageversion = $L['import_qtf']['Version'].' 2.0<br/>';

// --------
// SUBMITTED
// --------

if ( isset($_POST['ok']) )
{
  // check file
  if (!is_uploaded_file($_FILES['title']['tmp_name'])) $error = $L['import_qtf']['E_nofile'];

  // check form value
  if ( empty($error) )
  {
    $strFormat = trim($_POST['format']);
    $strDelimit = trim($_POST['delimit']);
    if ( $strFormat=='SQL' ) $strDelimit = ',';
    $strEnclose = $_POST['enclose'];  if ( get_magic_quotes_gpc() ) $strEnclose = stripslashes($_POST['enclose']);
    $strNull = trim($_POST['null']);
    if ( isset($_POST['dropbbc']) ) $strDropbbc='Y';
    if ( isset($_POST['skip']) ) $strSkip='Y';
    if ( isset($_POST['status']) ) $strStatus=$_POST['status'];
    if ( empty($strDelimit) ) $error=$L['export']['Delimiter'].S.$L['E_invalid'];
    $s = intval($_POST['s']);
    $_SESSION['m_import_qtf']=array($strTitle,$strFormat,$strDelimit,$strEnclose,$strNull,$strDropbbc,$strSkip,$s,$strStatus);
  }

  // check values
  if ( empty($error) )
  {
    if ( strlen($strDelimit)==1 )
    {
    if ( ereg('[0-9A-Za-z]',$strDelimit) ) $error=$L['export']['Delimiter'].S.$L['E_invalid'];
    }
    if ( strlen($strEnclose)==1 )
    {
    if ( ereg('[0-9A-Za-z]',$strEnclose) ) $error=$L['export']['Enclose'].S.$L['E_invalid'];
    }
  }

  // save and run
  if ( empty($error) )
  {
    if ( empty($_POST['null']) ) { $strNull=S; } else { $strNull=$_POST['null']; }

    if ( $_FILES['title']['type']!='text/plain' )
    {
    $error = $L['import_qtf']['E_format'];
    unlink($_FILES['title']['tmp_name']);
    }

    // read lines
    $handle = fopen($_FILES['title']['tmp_name'],'r');
    if ( $handle )
    {
      if ( $strSkip=='Y' ) $str = fgets($handle);

      // -----
      $i = 0;
      $intCountPost = 0;
      $intCountTopic = 0;
      $intNextTopic = Nextid(TABTOPIC);

      while ( !feof($handle) )
      {
        $i++;
        $str = fgets($handle);
        if ( strlen($str)<4 ) continue;

        if ( $strFormat=='SQL' )
        {
        $str = trim(strstr($str,'VALUES ('));
        $str = substr($str, 8, -1);
        }
        // bbc html
        if ( $strDropbbc=='Y' )
        {
        $str = QTbbc($str,'drop',false);
        }

        // import line (0:id 1:forum 2:topic 3:type 4:username 5:title 6:issuedate 7:numid 8:textmsg
        if ( substr_count($str, $strDelimit)>7 )
        {
          $arrStr = explode($strDelimit,$str);

          if ( count($arrStr)==9 )
          {
            // pre-process values, remove encloser, html quote
            For ($j=0;$j<9;$j++)
            {
              $arrStr[$j]=trim($arrStr[$j]);
              if ( substr($arrStr[$j],0,1)==$strEnclose && substr($arrStr[$j],-1,1)==$strEnclose ) $arrStr[$j]=substr($arrStr[$j],1,-1);
              $arrStr[$j] = htmlspecialchars($arrStr[$j],ENT_QUOTES);
            }

            $intPost     = Nextid(TABPOST);
            $intTopic    = $intNextTopic+$arrStr[2];
            $strType     = ($arrStr[3]==$strNull ? 'NULL' : '"'.$arrStr[3].'"');
            $strUsername = ($arrStr[4]==$strNull ? 'NULL' : '"'.$arrStr[4].'"');
            $strTitle    = ($arrStr[5]==$strNull ? 'NULL' : '"'.$arrStr[5].'"');
            $intIssuedate= ($arrStr[6]==$strNull ? 'NULL' : '"'.$arrStr[6].'"');
            $intNumid    = $arrStr[7];
            $strTextmsg  = '"'.$arrStr[8].'"';

            $oDB->Query('INSERT INTO '.TABPOST." (id,forum,topic,type,userid,username,title,issuedate,textmsg) VALUES ($intPost,$s,$intTopic,$strType,0,$strUsername,$strTitle,$intIssuedate,$strTextmsg)");
            $intCountPost++;

            if ( ($arrStr[3]=='P') || ($arrStr[3]=='A') )
            {
              if ( $arrStr[3]=='P' ) $strType='"T"';
              if ( $arrStr[4]=='NULL' ) $arrStr[4]='Visitor';
              $oDB->Query('INSERT INTO '.TABTOPIC." (id,numid,forum,type,status,firstpostid,lastpostid,firstpostuser,lastpostuser,firstpostname,lastpostname,firstpostdate,lastpostdate) VALUES ($intTopic,$intNumid,$s,$strType,\"{$_POST['status']}\",$intPost,$intPost,0,0,$strUsername,$strUsername,$intIssuedate,$intIssuedate)");
              $intCountTopic++;
            }
          }
          else
          {
            $error='Number of parameters ('.count($arrStr).') not matching in line '.$i;
          }
        }
        else
        {
        $error='Not enough delimiters ('.substr_count($str, $strDelimit).') in line '.$i;
        }
      }
      // ----
      fclose($handle);

      // udate stats
      if ( $intCountPost>0 || $intCountTopic>0 )
      {
      $oSEC = new cSection;
      UpdateSectionStats($s);
      }
    }
  }

  if ( empty($error) )
  {
    unlink($_FILES['title']['tmp_name']);
    $oVIP->EndMessage(NULL,$L['import_qtf']['S_import'],'admin',0);
  }
}

// --------
// HTML START
// --------

$bJava=true;
include('qtf_adm_p_header.php');
include('qtf_adm_p_title.php');

if ( isset($_SESSION['m_import_qtf']) )
{
$strTitle   = $_SESSION['m_import_qtf'][0];
$strFormat  = $_SESSION['m_import_qtf'][1];
$strDelimit = $_SESSION['m_import_qtf'][2];
$strEnclose = $_SESSION['m_import_qtf'][3];
$strNull    = $_SESSION['m_import_qtf'][4];
$strDropbbc = $_SESSION['m_import_qtf'][5];
$strSkip    = $_SESSION['m_import_qtf'][6];
$s   = $_SESSION['m_import_qtf'][7];
$strStatus  = $_SESSION['m_import_qtf'][8];
}

echo '
<script type="text/javascript">
<!--
function ValidateForm(theForm)
{
  if (theForm.title.value.length==0) { alert(qtHtmldecode("',$L['E_mandatory'],': File")); return false; }
  return null;
}
-->
</script>
';

echo "<form method=\"post\" action=\"$oVIP->selfurl\" enctype=\"multipart/form-data\" onsubmit=\"return ValidateForm(this);\">\n";
echo '<input type="hidden" name="maxsize" value="5242880"/>',N;
echo '<table class="data_o" cellspacing="0">',N;

echo '<tr class="data_o">',N;
echo '<td class="th_o th_o_all" colspan="2">',$L['import_qtf']['File'],'</td>',N;
echo '</tr>',N;

echo '<tr class="data_o">',N;
echo '<td class="th_o th_o_first" style="width:200px"><label for="title">',$L['import_qtf']['File'],'</label></td>',N;
echo '<td class="td_o"><input type="file" id="title" name="title" size="32" value="',$strTitle,'"/></td>',N;
echo '</tr>',N;

echo '<tr class="data_o">',N;
echo '<td class="th_o th_o_all" colspan="2">',$L['Adm_settings'],'</td>',N;
echo '</tr>',N;

echo '<tr class="data_o">',N;
echo '<td class="th_o th_o_first"><label for="format">',$L['import_qtf']['Format'],'</label></td>',N;
echo '<td class="td_o"><select id="format" name="format">',N;
echo '<option value="CSV"',($strFormat=='CSV' ? QSEL : ''),'>',$L['import_qtf']['Csv'],'</option>',N;
echo '<option value="SQL"',($strFormat=='SQL' ? QSEL : ''),'>',$L['import_qtf']['Sql'],'</option>',N;
echo '</select></td>',N;
echo '</tr>',N;

echo '<tr class="data_o">',N;
echo '<td class="th_o th_o_first"><label for="delimit">',$L['import_qtf']['Delimiter'],'</label></td>',N;
echo '<td class="td_o"><input type="text" id="delimit" name="delimit" size="1" maxlength="5" value="',$strDelimit,'"/></td>',N;
echo '</tr>',N;

echo '<tr class="data_o">',N;
echo '<td class="th_o th_o_first"><label for="enclose">',$L['import_qtf']['Encloser'],'</label></td>',N;
echo '<td class="td_o"><input type="text" id="enclose" name="enclose" size="1" maxlength="5" value="',htmlspecialchars($strEnclose),'"/></td>',N;
echo '</tr>',N;

echo '<tr class="data_o">',N;
echo '<td class="th_o th_o_first"><label for="null">',$L['import_qtf']['Null'],'</label></td>',N;
echo '<td class="td_o"><input type="text" id="null" name="null" size="5" maxlength="24" value="',$strNull,'"/> ',$L['import_qtf']['H_Null'],'</td>',N;
echo '</tr>',N;

echo '<tr class="data_o">',N;
echo '<td class="th_o th_o_first">',$L['import_qtf']['First_line'],'</td>',N;
echo '<td class="td_o"><input type="checkbox" id="skip" name="skip"',($strSkip=='Y' ? QCHE : ''),'/><label for="skip">',$L['import_qtf']['HFirst_line'],'</label></td>',N;
echo '</tr>',N;

echo '<tr class="data_o">',N;
echo '<td class="th_o th_o_all" colspan="2">',$L['Destination'],'</td>',N;
echo '</tr>',N;

echo '<tr class="data_o">
<td class="th_o th_o_first" style="width:200px"><label for="s">',$L['import_qtf']['Destination'],'</label></td>
<td class="td_o"><select id="s" name="s">',QTastags(GetSectionTitles('A'),null,$s),'</select> <a href="qtf_adm_sections.php">',$L['Section_add'],'</a></td>
</tr>
';
echo '<tr class="data_o">',N;
echo '<td class="th_o th_o_first">',$L['import_qtf']['Drop_bbc'],'</td>',N;
echo '<td class="td_o"><input type="checkbox" id="dropbbc" name="dropbbc"',($strDropbbc=='Y' ? QCHE : ''),'/><label for="dropbbc">',$L['import_qtf']['HDrop_bbc'],'</label></td>',N;
echo '</tr>
';
echo '<tr class="data_o">
<td class="th_o th_o_first"><label for="status">',$L['Status'],'</label></td>
<td class="td_o"><select id="status" name="status">',QTastags($oSYS->statuses,null,$strStatus),'</select></td>
</tr>
';
echo '<tr class="data_o">',N;
echo '<td class="th_o" colspan="2" style="padding:6px; text-align:center"><input type="submit" name="ok" value="',$L['Ok'],'"/></td>',N;
echo '</tr>
';
echo '</table>
</form>
';

// HTML END

include('qtf_adm_p_footer.php');

?>